
package glzt.ui.video;

import glzt.util.ProfileList;
import glzt.wifi.control.R;
import java.net.DatagramSocket;
import java.util.Date;
import android.content.Context;
//import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Rect;

import android.util.AttributeSet;

import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

import android.view.SurfaceHolder.Callback;

public class MonitorCtrlSurfaceView extends SurfaceView implements Callback,
		Runnable {

	public static boolean isSocketOK = true; 
	public static int recvFailedCount = 0;

	protected static final int MAX_VELOCITY_X = 2000;
	protected static final int MAX_VELOCITY_Y = 2000;

	private Thread threadDraw;
	private SurfaceHolder sfh;
	private Canvas canvas;

	private Paint paint;
	private boolean drawFlag;

	public static int screenWidth = 0, screenHeight = 0;

	public static ProfileList currentPL = new ProfileList();

	private static Bitmap bmpBackground;// 

	private static Matrix matrixDir = new Matrix();// , matrixBar, matrixLever;

	private static Rect dirtyACC = new Rect();
	private static Rect dirtyDIR = new Rect();

	public static boolean isUDPConnected = false;
	public static DatagramSocket udpSocket = null;

	public MonitorCtrlSurfaceView(Context context, AttributeSet attrs) {
		super(context);
		// Log.v("Mike144", "ControlSurfaceView invoked");
		this.setKeepScreenOn(true);
		sfh = this.getHolder();// ͨSurfaceHolderӿڷSurface.getHolder()Եõӿڡ
		sfh.addCallback(this);// ûʵִ˽ӿڽsurface仯Ϣ
		paint = new Paint();
		paint.setAntiAlias(true);
		setFocusable(true);
		setFocusableInTouchMode(true);
	}

	/**
	 * SurfaceHolder.Callback ûʵִ˽ӿڽsurface仯ϢһSurfaceView ʱ
	 * ֻSurfaceHolder.Callback .surfaceCreated()SurfaceHolder.Callback
	 * .surfaceDestroyed()֮Ч. CallbackķSurfaceHolder.addCallback.
	 */

	@Override
	public void surfaceCreated(SurfaceHolder holder) {

		//dalvikVm.VMRuntime.getRuntime().setTargetHeapUtilization(TARGET_HEAP_UTILIZATION);

		//  λͼ
		bmpBackground = BitmapFactory.decodeResource(getResources(),
				R.drawable.bg);
		threadDraw = new Thread(this);
		drawFlag = true;
		threadDraw.start();

	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {

		// ʱԭϽǣΪyΪ; ΪxΪ
		screenWidth = width;
		screenHeight = height;

	}

	@Override
	public void surfaceDestroyed(SurfaceHolder holder) {
		drawFlag = false;

	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		// synchronized (mPointers) {

		return true;
		// }
	}

	public void draw() {

		matrixDir.reset();// þʶ
		try {
			canvas = sfh.lockCanvas(dirtyACC);
			canvas.drawBitmap(bmpBackground, 0, 0, paint);

		} catch (Exception e) {
		} finally {
			try {
				if (canvas != null)
					sfh.unlockCanvasAndPost(canvas);
			} catch (Exception e2) {
			}
		}

	}

	@Override
	public void run() {
		Date d = null;
		long ms = 0;

		while (drawFlag) {
			d = new Date();
			draw();

			ms = new Date().getTime() - d.getTime();
			d = null;
			try {
				Thread.sleep(Math.max(0, 100 - ms));
			} catch (Exception ex) {
			}
		}
	}

}
