/*
 * Copyright (C) 2011 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package glzt.wifi.control;

import glzt.util.ConstantData;
import glzt.util.ProfileList;

import java.io.IOException;
import java.io.InputStream;
import java.net.Socket;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.TextView;
import android.widget.ToggleButton;
import java.util.Timer;
import java.util.TimerTask;

public class BasicGLSurfaceViewActivity extends Activity implements OnClickListener, OnCheckedChangeListener, OnLongClickListener{

    @Override
    protected void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        //mView = new BasicGLSurfaceView(getApplication());
        
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);//ȥ⣨Ӧõ) 
		//趨ҪдsetContentView֮ǰ쳣
		this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		//setContentView(new ControlSurfaceView(this));
		
        //setContentView(mView);
        
		findView();
    }

    @Override
    protected void onPause() {
    	if(null != mReceiveThread){
        	stop = true;
        }
        super.onPause();
        //mView.onPause();
    }

    @Override
    protected void onResume() {
    	findView();
        super.onResume();
        //mView.onResume();
    }

	@Override
	public boolean onLongClick(View v) {

		if(v == btnTrimUp){
			setTimer(btnTrimUp);	    
		}else if(v == btnTrimDown){
			setTimer(btnTrimDown);
		}else if(v == btnTrimLeft){			
			setTimer(btnTrimLeft);
		}else if(v == btnTrimRight){
			setTimer(btnTrimRight);
		}else if(v == btnDRUp){
			setTimer(btnDRUp);
		}else if(v == btnDRDown){
			setTimer(btnDRDown);
		}else if(v == btnDRLeft){
			setTimer(btnDRLeft);
		}else if(v == btnDRRight){
			setTimer(btnDRRight);
		}		
		return false;
	
	}
	
	@Override
	protected void onDestroy() {
    	if(mReceiveThread != null)
    	{
    		stop = true;
    		Log.i("BasicGLSurfaceViewActivity","RecieveThread destoryed...");
    	}
		super.onDestroy();
	}

	@Override
	public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {

		//isCheckedǰť״̬  
        if(isChecked){  
        	visibleFlag = true;
        	BasicGLSurfaceView.isInRealTimeCfg = visibleFlag;
        	setRealTimeCfgVisible(visibleFlag);
        	
        }else{
        	// ťoff״̬ػٿؽ(ȥť
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
			visibleFlag = false;
			setRealTimeCfgVisible(visibleFlag);
        }        
	
	}

	@Override
	public void onClick(View v) {

		Message tmpMsg = new Message();
        if (v == btnConfig) { 
        	Intent intent0 = new Intent(BasicGLSurfaceViewActivity.this, ConfigAllActivity.class);
						
			Bundle bundle = new Bundle();  
            bundle.putString("fromActivity", "BasicGLSurfaceViewActivity");  
             
            intent0.putExtras(bundle);
    		startActivity(intent0);    				
        } else if (v == btnBack) {
        	// Ϣأ
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
        	if(mReceiveThread != null)
        	{
        		stop = true;
        		//mReceiveThread.interrupt();
        		Log.i("Mike","RecieveThread destoryed...");
        	}
        	if(activityName.equals("WifiControlActivity")){
        		Intent intent0 = new Intent(BasicGLSurfaceViewActivity.this, WifiControlActivity.class);
        		Bundle bundle = new Bundle();
                bundle.putString("fromActivity", "BasicGLSurfaceViewActivity"); 
                intent0.putExtras(bundle);
             	startActivity(intent0);
        	}else if(activityName.equals("ConfigAllActivity")){
        		Intent intent0 = new Intent(BasicGLSurfaceViewActivity.this, ConfigAllActivity.class);
        		Bundle bundle = new Bundle(); 
                bundle.putString("fromActivity", "BasicGLSurfaceViewActivity"); 
                intent0.putExtras(bundle);
             	startActivity(intent0);
        	}else{
        		finish();
        	}
        } else if(v == btnTrimUp){
			//btnTrimUp.setVisibility(v.INVISIBLE);
			iTrimUpDown++;
			if(iTrimUpDown > ConstantData.MAXIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MAXIMUM_TRIM_VALUE;			
			tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
        	// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}else if(v == btnTrimDown){
			iTrimUpDown--;
			if(iTrimUpDown < ConstantData.MINIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MINIMUM_TRIM_VALUE;
			tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
			// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}else if(v == btnTrimLeft){			
			iTrimLeftRight--;
			if(iTrimLeftRight < ConstantData.MINIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MINIMUM_TRIM_VALUE;
			tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");
        	// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}else if(v == btnTrimRight){
			iTrimLeftRight++;
			if(iTrimLeftRight > ConstantData.MAXIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MAXIMUM_TRIM_VALUE;
			tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");
			// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}else if(v == btnDRUp){
			iDRUpDown++;
			if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
			tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
			// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}else if(v == btnDRDown){
			iDRUpDown--;
			if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
			tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
			// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}else if(v == btnDRLeft){
			iDRLeftRight--;
			if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
			tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");
			// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}else if(v == btnDRRight){
			iDRLeftRight++;
			if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
			tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");
			// ʵʱֵ
        	BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
        	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
        	BasicGLSurfaceView.commitConfig();
		}
	}
	
    private void findView(){
    	// surfaceViewsocketϢڻûݸwifiģ
    	app = ((ConnectWifiApplication) getApplicationContext());
		BasicGLSurfaceView.socketServer = app.getCurServerSocket();		        
		BasicGLSurfaceView.currentPL = app.readCurrentProfile();
		
		pl = app.readCurrentProfile();
		
		if(ConstantData.BASIC_TOUCH_MODE == pl.iControlMode){
			setContentView(R.layout.gl_layout);
		}else if(ConstantData.BASIC_TOUCH_REV_MODE == pl.iControlMode){
			setContentView(R.layout.gl_reverse_layout);
		}    			 
        
		mView = (BasicGLSurfaceView)findViewById(R.id.GLSurfaceView);
				
        btnConfig = (Button) findViewById(R.id.Config);  
        btnConfig.setOnClickListener(this);  
            	        
        btnBack = (Button) findViewById(R.id.Back);  
        btnBack.setOnClickListener(this);
        
        btnTrimUp = (Button)findViewById(R.id.btnTrimUp);
        btnTrimUp.setOnClickListener(this);
        btnTrimUp.setOnLongClickListener(this);
        
        btnTrimDown = (Button)findViewById(R.id.btnTrimDown);
        btnTrimDown.setOnClickListener(this);
        btnTrimDown.setOnLongClickListener(this);
        
        btnTrimLeft = (Button)findViewById(R.id.btnTrimLeft);
        btnTrimLeft.setOnClickListener(this);
        btnTrimLeft.setOnLongClickListener(this);
        
        btnTrimRight = (Button)findViewById(R.id.btnTrimRight);
        btnTrimRight.setOnClickListener(this);
        btnTrimRight.setOnLongClickListener(this);
        
        btnDRUp = (Button)findViewById(R.id.btnDRUp);
        btnDRUp.setOnClickListener(this);
        btnDRUp.setOnLongClickListener(this);

        btnDRDown = (Button)findViewById(R.id.btnDRDown);
        btnDRDown.setOnClickListener(this);
        btnDRDown.setOnLongClickListener(this);

        btnDRLeft = (Button)findViewById(R.id.btnDRLeft);
        btnDRLeft.setOnClickListener(this);
        btnDRLeft.setOnLongClickListener(this);
        
        btnDRRight = (Button)findViewById(R.id.btnDRRight);
        btnDRRight.setOnClickListener(this);
        btnDRRight.setOnLongClickListener(this);
        
        tvTrimUpDown = (TextView)findViewById(R.id.tvTrimUpDown);
        tvTrimLeftRight = (TextView)findViewById(R.id.tvTrimLeftRight);
        
        tvDRUpDown = (TextView)findViewById(R.id.tvDRUpDown);
        tvDRLeftRight = (TextView)findViewById(R.id.tvDRLeftRight);
        
        tglBtnRealTimeCfg=(ToggleButton)findViewById(R.id.tglBtnRealTimeCfg); 
        tglBtnRealTimeCfg.setTextOn("Setup");
        tglBtnRealTimeCfg.setTextOff("Setup");
        tglBtnRealTimeCfg.setOnCheckedChangeListener(this);
        visibleFlag = tglBtnRealTimeCfg.isChecked();
        BasicGLSurfaceView.isInRealTimeCfg = visibleFlag;
        
        setRealTimeCfgVisible(visibleFlag);        
        
        //õactivityʱ
        intent = this.getIntent();  
        activityName = intent.getStringExtra("fromActivity");
        
        iTrimUpDown = BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC];
        iTrimLeftRight = BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR];
        tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
        tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");
        
        iDRUpDown = BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC];
        iDRLeftRight = BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR];
        tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
        tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");
        
        BasicGLSurfaceView.commitConfig();
        
        //android.util.DisplayMetrics  
        DisplayMetrics dm = new DisplayMetrics();  
        getWindowManager().getDefaultDisplay().getMetrics(dm);  
          
        BasicGLSurfaceView.screenWidth = dm.widthPixels;
        BasicGLSurfaceView.screenHeight = dm.heightPixels;
        
        // ȡ/ʾwifiϢ:
        tvWifiStatus = (TextView)findViewById(R.id.tvWifiStatus);
        tvWifiStatus.setVisibility(View.INVISIBLE);
        
        wifiManager = (WifiManager)this.getSystemService(Context.WIFI_SERVICE);        
        
        // Ϣ߳(߳ʱʾwifiϢĹ)
        if(null != BasicGLSurfaceView.socketServer){
        	mReceiveThread = new ReceiveThread(BasicGLSurfaceView.socketServer);
        	stop = false;
        	//߳
        	mReceiveThread.start();
        }
    }  

	private void setRealTimeCfgVisible(boolean vFlag){
		if(!vFlag){
			btnTrimUp.setVisibility(View.INVISIBLE);
			btnTrimDown.setVisibility(View.INVISIBLE);
			btnTrimLeft.setVisibility(View.INVISIBLE);
			btnTrimRight.setVisibility(View.INVISIBLE);
			btnDRUp.setVisibility(View.INVISIBLE);
			btnDRDown.setVisibility(View.INVISIBLE);
			btnDRLeft.setVisibility(View.INVISIBLE);
			btnDRRight.setVisibility(View.INVISIBLE);
			btnConfig.setVisibility(View.INVISIBLE);
			btnBack.setVisibility(View.INVISIBLE);
			
		}else{
			btnTrimUp.setVisibility(View.VISIBLE);
			btnTrimDown.setVisibility(View.VISIBLE);
			btnTrimLeft.setVisibility(View.VISIBLE);
			btnTrimRight.setVisibility(View.VISIBLE);
			btnDRUp.setVisibility(View.VISIBLE);
			btnDRDown.setVisibility(View.VISIBLE);
			btnDRLeft.setVisibility(View.VISIBLE);
			btnDRRight.setVisibility(View.VISIBLE);
			btnConfig.setVisibility(View.VISIBLE);
			btnBack.setVisibility(View.VISIBLE);			
		}			
	}
	
	Handler handlerAll = new Handler() {
		public void handleMessage(Message msg) {
			switch(msg.what) {
				case SHOW_WIFI_STATUS:
					tvWifiStatus.setVisibility(View.VISIBLE);
					String textStr = msg.getData().getString("WifiStatus");
					tvWifiStatus.setText(textStr);
	    	        tvWifiStatus.invalidate();
	    	        break;
				case TRM_UP:
					iTrimUpDown++;
                	if(iTrimUpDown > ConstantData.MAXIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MAXIMUM_TRIM_VALUE;
                	tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");
                	break;
				case TRM_DOWN:
					iTrimUpDown--;
					if(iTrimUpDown < ConstantData.MINIMUM_TRIM_VALUE) iTrimUpDown = ConstantData.MINIMUM_TRIM_VALUE;
					tvTrimUpDown.setText(String.valueOf(iTrimUpDown)+"%");                  	
					break;
				case TRM_LEFT:
					iTrimLeftRight--;
					if(iTrimLeftRight < ConstantData.MINIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MINIMUM_TRIM_VALUE;
					tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");               	
					break;
				case TRM_RIGHT:
					iTrimLeftRight++;
					if(iTrimLeftRight > ConstantData.MAXIMUM_TRIM_VALUE) iTrimLeftRight = ConstantData.MAXIMUM_TRIM_VALUE;
					tvTrimLeftRight.setText(String.valueOf(iTrimLeftRight)+"%");                	
					break;
				case DR_UP:
					iDRUpDown++;
					if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
					tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
					break;
				case DR_DOWN:
					iDRUpDown--;
					if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
					tvDRUpDown.setText(String.valueOf(iDRUpDown)+"%");
					break;
				case DR_LEFT:
					iDRLeftRight--;
					if(iDRUpDown < ConstantData.MINIMUM_DR_VALUE) iDRUpDown = ConstantData.MINIMUM_DR_VALUE;
					tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");               	
					break;
				case DR_RIGHT:
					iDRLeftRight++;
					if(iDRUpDown > ConstantData.MAXIMUM_DR_VALUE) iDRUpDown = ConstantData.MAXIMUM_DR_VALUE;
					tvDRLeftRight.setText(String.valueOf(iDRLeftRight)+"%");               	
					break;
			}
			super.handleMessage(msg);
		}
	};
	
	private void setTimer(final Button btn){
		final Timer t = new Timer();
        TimerTask tt = new TimerTask(){
            @Override
            public void run(){
                if(btn.isPressed()){
                	Message message = new Message();
                	if(btnTrimUp == btn){
                	   message.what = TRM_UP;
                	}else if(btnTrimDown == btn){
                 	   message.what = TRM_DOWN;
                 	}else if(btnTrimLeft == btn){
                  	   message.what = TRM_LEFT;
                  	}else if(btnTrimRight == btn){
                  	   message.what = TRM_RIGHT;
                  	}else if(btnDRUp == btn){
                  	   message.what = DR_UP;
                  	}else if(btnDRDown == btn){
                  	   message.what = DR_DOWN;
                  	}else if(btnDRLeft == btn){
                  	   message.what = DR_LEFT;
                  	}else if(btnDRRight == btn){
                  	   message.what = DR_RIGHT;
                  	}
    		    	handlerAll.sendMessage(message);	                	
                }else{
                	// ť, ʱȥֵ(ջ͸º)
                	if((btnTrimUp == btn)||(btnTrimDown == btn)){
                		BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_ACC]=iTrimUpDown;
                    	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
                    	BasicGLSurfaceView.commitConfig();
                  	}else if((btnTrimLeft == btn)||(btnTrimRight == btn)){
                    	BasicGLSurfaceView.currentPL.iTrim[ConstantData.CHANNEL_DIR]=iTrimLeftRight;
                    	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
                    	BasicGLSurfaceView.commitConfig();
                   	}else if((btnDRUp == btn)||(btnDRDown == btn)){
                   		BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_ACC]=iDRUpDown;
                    	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
                    	BasicGLSurfaceView.commitConfig();
                   	}else if((btnDRLeft == btn)||(btnDRRight == btn)){
                   		BasicGLSurfaceView.currentPL.iDR[ConstantData.CHANNEL_DIR]=iDRLeftRight;
                    	app.updateConfigToApp(BasicGLSurfaceView.currentPL);
                    	BasicGLSurfaceView.commitConfig();
                   	}
                	t.cancel();
            	}
            }
        };        
        t.schedule(tt, 50, 50);
	}
	
	
	private class ReceiveThread extends Thread
	{
	    private InputStream inStream = null;
	    
	    private byte[] buf;  
	    //private String str = null;
	    
	    ReceiveThread(Socket s)
	    {
	        try {
	            //
	            this.inStream = s.getInputStream();
	        } catch (IOException e) {
	            e.printStackTrace();
	        }
	    }      
	    
	    @Override
	    public void run()
	    {
	        while(!stop)
	        {
	            this.buf = new byte[512];
	            
	            if((null != app.getCurServerSocket())&&(null!=this.inStream))
	            {
	            	try {
	            		//ȡݣ
	            		this.inStream.read(this.buf);
	            	} catch (IOException e) {
	            		e.printStackTrace();
	            	} 
	            }else{
	            	stop = true;
	            	if(null==this.inStream)
	            		Log.e("BasicGLSurfaceViewActivity","inStream is null!!!!");
	            	break;
	            }
	            
	            /*
	            // ȡ/ʾwifiٶ/ǿ
    	        String textStr = new String();
    	        int level=INVALID_VALUE;
    	        WifiInfo wifiInfo = wifiManager.getConnectionInfo();
    	        if ((wifiInfo != null)&&(wifiManager.isWifiEnabled())) {
    	            int linkSpeed = wifiInfo.getLinkSpeed(); //measured using WifiInfo.LINK_SPEED_UNITS
    	            textStr = ("W:"+String.valueOf(linkSpeed)+"M");
    	            level = wifiInfo.getRssi();
    	            if(INVALID_VALUE!=level){
    	            	textStr+=","+String.valueOf(level)+"dBm";
    	            }else{
    	            	textStr+=",--dBm";
    	            }
    	        }else{
    	        	textStr = ("W:--M,--dBm");
    	        }
    	        
    	        Message message = new Message();
    	        message.getData().putString("WifiStatus", textStr);
		    	message.what = SHOW_WIFI_STATUS;
		    	handlerAll.sendMessage(message);
    	        // ȡ/ʾwifiٶ/ǿ  
    	        */
		    	
		    	// ÿ100msһ߳
		    	try {
					Thread.sleep(100);
				} catch (Exception ex) {
				}
	        }
	        /*
	        if((stop)&&(null != this.inStream)){
				try {
					this.inStream.close();
					Log.i("inStream closed","BasicGLSurfaceViewActivity");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        }
	        */
	    }  
	}
	
	protected static final int SHOW_WIFI_STATUS = 1001;
	protected static final int TRM_UP = 1002;
	protected static final int TRM_DOWN = 1003;
	protected static final int TRM_LEFT = 1004;
	protected static final int TRM_RIGHT = 1005;
	protected static final int DR_UP = 1006;
	protected static final int DR_DOWN = 1007;
	protected static final int DR_LEFT = 1008;
	protected static final int DR_RIGHT = 1009;
	
	// ³surfaceViewϢͶ
	protected static final int MSG_RT_TRM_UP    = 4010;
	protected static final int MSG_RT_TRM_DOWN  =4011;
	protected static final int MSG_RT_TRM_LEFT  =4012;
	protected static final int MSG_RT_TRM_RIGHT = 4013;
	protected static final int MSG_RT_DR_UP = 4020;
	protected static final int MSG_RT_DR_DOWN = 4021;
	protected static final int MSG_RT_DR_LEFT = 4022;
	protected static final int MSG_RT_DR_RIGHT = 4023;
	
	private Button btnConfig, btnBack;  
	private ToggleButton tglBtnRealTimeCfg;
	private boolean visibleFlag = false;// ʼĬΪȥť
    
    private Button btnTrimUp,btnTrimDown,btnTrimLeft,btnTrimRight;
	private Button btnDRUp,btnDRDown,btnDRLeft,btnDRRight;
	private static int iTrimUpDown = ConstantData.DEFAULT_TRIM_VALUE,iTrimLeftRight = ConstantData.DEFAULT_TRIM_VALUE;
	private static int iDRUpDown = ConstantData.DEFAULT_DR_VALUE,iDRLeftRight = ConstantData.DEFAULT_DR_VALUE;
    private static TextView tvWifiStatus;
	
	private TextView tvTrimUpDown,tvTrimLeftRight,tvDRUpDown,tvDRLeftRight;
	
    // ߳ʹñ
 	private boolean stop = true;
 	private ReceiveThread mReceiveThread = null;
 	
 	private ConnectWifiApplication app;
 	private Intent intent;
 	private String activityName;
 	 	
 	private ProfileList pl = new ProfileList();
 	
 	// wifiϢر
 	WifiManager wifiManager;
 	
    private BasicGLSurfaceView mView;
}
